function ImageButton (div, title, onaction, innerWidth, innerHeight)
{
	/**
	 * protected variables
	**/
	var _div = div;
	var _id = _div.id;
	var _enabled = true;
	var _inside = true;
	var _action = onaction;
	
	function _updateImages( status )
	{
		_div.childNodes[1].setAttribute( 'class', status );
		
		if ( status )
			status = '_' + status;
		
		_div.childNodes[0].src = 'Images/' + _id + '_left' + status + '.png';
		_div.childNodes[1].style.backgroundImage = 'url(Images/' + _id + '_middle' + status + '.png)';
		_div.childNodes[2].src = 'Images/' + _id + '_right' + status + '.png';
	}
	
	var _handleMouseDown = function(event)
	{
		if ( _enabled )
			_updateImages( 'active' );
		
		document.addEventListener("mousemove", _handleMouseMove, true);
		document.addEventListener("mouseup", _handleMouseUp, true);
		_div.addEventListener("mouseover", _handleMouseOver, true);
		_div.addEventListener("mouseout", _handleMouseOut, true);
		
		_inside = true;
		
		event.stopPropagation();
		event.preventDefault();
	}

	var _handleMouseMove = function(event)
	{
		event.stopPropagation();
		event.preventDefault();
	}
	
	var _handleMouseOver = function(event)
	{
		if (_enabled)
			_updateImages( 'active' );
		
		_inside = true;

		event.stopPropagation();
		event.preventDefault();
	}
	
	var _handleMouseOut = function(event)
	{
		if (_enabled)
			_updateImages( '' );
		
		_inside = false;
		
		event.stopPropagation();
		event.preventDefault();
	}
	
	var _handleMouseUp = function(event)
	{
		if (_enabled)
			_updateImages( '' );
		
		// callback to the client
		document.removeEventListener("mousemove", _handleMouseMove, true);
		document.removeEventListener("mouseup", _handleMouseUp, true);
		
		_div.removeEventListener("mouseover", _handleMouseOver, true);
		_div.removeEventListener("mouseout", _handleMouseOut, true);
		
		event.stopPropagation();
		event.preventDefault();
		
		if ( _action && _enabled && _inside ) {
			_action();
		}
	}

	this.setEnabled = function( enabled )
	{
		_enabled = enabled ? true : false;
		_updateImages( _enabled ? '' : 'disabled' );
	}

	_div.style.height = innerHeight + "px";
	_div.style.appleDashboardRegion = 'dashboard-region(control rectangle)';
	_div.style.cursor = 'pointer';
	_div.onmousedown = _handleMouseDown;
	
	var element = document.createElement('img');
	element.src = 'Images/' + _id + '_left.png';
	element.style.verticalAlign = 'top';
	_div.appendChild (element);
	
	element = document.createElement('div');
	element.style.display = 'inline-block';
	element.style.textAlign = 'center';
	element.style.backgroundImage = 'url(Images/' + _id + '_middle.png)';
	element.style.backgroundRepeat = 'repeat-x';
	element.style.width = innerWidth + "px";
	element.style.height = innerHeight + "px";
	element.innerHTML = title;
	_div.appendChild (element);
	
	element = document.createElement ('img');
	element.src = 'Images/' + _id + '_right.png';
	element.style.verticalAlign = 'bottom';
	_div.appendChild (element);
	
	// force the images to load.
	var img = new Image;
	img.src = 'Images/' + _id + '_left_active.png';
	var img = new Image;
	img.src = 'Images/' + _id + '_middle_active.png';
	var img = new Image;
	img.src = 'Images/' + _id + '_right_active.png';
	
	_div.setEnabled = this.setEnabled;
}